function clustering = barcodeclustering

cdir = pwd
wdir = '/res/users/pkuksa/.matlab/R14/dna/fast-mismatch/distribution/kernelbarcode-1.0c/'
cd(wdir)

datasets = {'ast','hesperiidae','batGuyana','bird2','fishAustralia','fishlarvae','acg'}
datasets = {'batGuyana','bird2','fishAustralia','fishlarvae','acg'}
datasets = {'fishAustralia'}
methods = {'mismatch -k 10 -m 0','mismatch -k 5 -m 1','double -d 5','triple -d 3','gapped -k 3 -g 4'}
methods = {'mismatch -k 5 -m 1'};

ndatasets = length(datasets)
nmethods = length(methods)
%fd = fopen('apcluster.all.results','w');
fd = fopen('tmpclust','w');
for i=1:ndatasets
  seq = fastaread(['datasets/' datasets{i} '.fasta']);
  nseq = length(seq);
  fprintf(fd,'%s ', datasets{i});
  for j=1:nmethods
    kernelcmd = ['python kernel-barcoding.py -t kernel -K ' methods{j} ' datasets/' datasets{i} '.fasta']
    [status] = system(kernelcmd)
    if (status~=0)
      fprintf(2,'Error in kernel evaluation script');
    end
    K=load('results/kernel.txt');
    k2 = sqrt(diag(K))+1e-12;
    k2 = k2*k2';
    K=K./k2;
    [idx,netsim,dpsim,expref] = apcluster(K,0.995,'maxits',500,'plot','dampfact',0.9);
    indc = unique(idx);
    clustcenters = {seq(indc).Header}';
    nclust = length(clustcenters);

    clustering(i,j).name = datasets{i};
    clustering(i,j).method = methods{j};
    clustering(i,j).clustcenters = clustcenters;
    clustering(i,j).nclust = nclust;
    clustering(i,j).clusteridx = idx;

    % cluster error
    nerr = 0;
    trueclass={};
    predclass={};
    for j1 = 1:nseq
      trueclass{j1}=regexprep(seq(j1).Header,'^([\S\s]+)\|([\S\s]+)\|','');
      predclass{j1}=regexprep(seq(idx(j1)).Header,'^([\S\s]+)\|([\S\s]+)\|','');
      if ~strcmpi(trueclass{j1},predclass{j1})
        nerr = nerr + 1;
      end
    end    
    clusterr = nerr/nseq;
    clustering(i,j).clusterr = clusterr;
    clustering(i,j).nerr = nerr;
    fprintf(1,'Clustering error (%s,%s) = %.4f', datasets{i}, methods{j}, clusterr);
    fprintf(fd,' & %.4f', clusterr);
    clear K
  end
  fprintf(fd,' \\\\\n');
end
cd(cdir)
