#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "shared.h"

int main(int argc, char **argv)
{
  int i, j, nStr;
  int *len;
  int **S;
  double *K, *diag;
  char *kernelfilename;
  FILE *kernelfile;

  kernelfilename = argv[1];

  kernelfile = fopen(kernelfilename, "r");
  if (!kernelfile) perror(kernelfilename), exit(2);
   
  len = (int *)malloc(MAXNSTR*sizeof(int));
  printf("Reading %s\n",kernelfilename);
  S = loadStrings(kernelfilename, len, &nStr);
  printf("Read %d strings\n", nStr);

  /* normalize kernel */
  diag = (double *)malloc(nStr*sizeof(double));
  for (i = 0; i < nStr; ++i)
    diag[i] = sqrt(S[i][i]); 
  K = (double *)malloc(nStr*nStr*sizeof(double));
  for (i = 0; i < nStr; ++i)
    for (j = 0; j < nStr; ++j)
      K[i+j*nStr] = S[i][j] / diag[i] / diag[j];
  saveKernelDouble(K,nStr,nStr,"%.6f ",strcat(kernelfilename,".normalized"));
  return 0;
}
