
#define STRMAXLEN 10000000
#define MAXNSTR 100000

typedef struct Feature
{
  int *features;
  int *group;
  int n;
} Features;

typedef struct Combinations
{
  int n;
  int k;
  double num_comb;
  int *comb;
} Combination;

int **loadStrings(char *filename, int* len, int *nStr);
double **loadStringsDouble(char *filename, int* len, int *nStr);
int *cntsrtna(int *sx, int k, int r, int na);
int *cntsrtna_gapped(int *sx, int g, int k, int r, int na, Combination *combinations);
int *cntsrtna_comb(int *sx, int k, int r, int na, int *comb);
void countAndUpdate(int *outK, int *sx, int *g, int k, int r, int nStr);
void countAndUpdate_vector(int *outK, int *sx, int *g, int k, int r, int nStr, int nq);
void countAndUpdate_comb(int *outK, int *sx, int *g, int k, int r, int nStr, int *regroup, int *comb);
void countAndUpdate_comb_vector(int *outK, int *sx, int *g, int k, int r, int nStr, int *regroup, int *comb, int nq);
void countAndUpdate_double_gapped(double *outK, int *sx, int *g, int *regroup, int k, int r, int nStr, Combination *combinations);
void countAndUpdate_double_gapped_vector(double *outK, int *sx, int *g, int *regroup, int k, int r, int nStr, Combination *combinations, int nq);
double nchoosek(int n, int k);
Combination *getCombinations(int n, int k);
void traverseCombinations(const int *elems, int n, int k, int *pos, int depth, int margin, int *cnt_comb, int *out, int num_comb);
int saveKernelDouble(double *K, int n, int m, const char *format, char *filename);
int saveKernelInt(int *K, int n, int m, const char *format, char *filename);
